import { Client } from 'pg';
//
import IKDB from './../Prototype/IKDB';
//
export default class IKDB_PSQL extends IKDB {
  constructor(config, transaction) {
    super(config, transaction)
    const localConsole = (transaction ? transaction.logger : console);
    if (config && config.database) { localConsole.debug(`Using database: ${config.database} with config: ${config}`); }
    this.database = config.database;
    this.connection = null;
  }
  //Overwrites
  async connect() { return await (await this._getConnection()).connect(); }
  async cleanup() { return await (await this._getConnection()).end(); }
  async beginTransaction() { return await (await this._getConnection()).query('START TRANSACTION'); }
  async commit() { return await (await this._getConnection()).query('COMMIT'); }
  async rollback() { return await (await this._getConnection()).query('ROLLBACK'); }
  async runQuery(qry) { return await qry.run(await this._getConnection()); }
  //tracker support
  getTrackerStats() { return null; }
  //Public 
  async sanitize(val) { return val; }

  /* private */
  async _getConnection() {
    if (!this.PSQL_CONN) this.PSQL_CONN = await this._newConnection(this.config);
    return this.PSQL_CONN;
  }
  _newConnection(config) {
    return new Promise((resolve, reject) => {
      const conn = new Client({
        host: config.host, database: config.database,
        port: config.port, user: config.user,
        password: config.password, max: 20
      });
      resolve(conn);
    });
  }
}
